/* Time-stamp: <2007-02-06 23:52:10 poser> */
/*
 * Copyright (C) 2006-2007 William J. Poser.
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General
 * Public License as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

/* Number systems */

#define NS_ALLZERO (-2)
#define NS_UNKNOWN (-1)
#define NS_AEGEAN					 1
#define NS_ARABIC_WESTERN				 3
#define NS_ARABIC_ALPHABETIC				 5
#define NS_ARMENIAN_ALPHABETIC				 7
#define NS_BALINESE					 9
#define NS_BENGALI					11
#define NS_BURMESE					13
#define NS_CHINESE_GENERIC				14
#define NS_CHINESE_SUZHOU				15
#define NS_CHINESE_REGULAR_TRADITIONAL			17
#define NS_CHINESE_MANDARIN_REGULAR_TRADITIONAL		18
#define NS_CHINESE_REGULAR_PLACE			19
#define NS_CHINESE_REGULAR_SIMPLIFIED			21
#define NS_CHINESE_MANDARIN_REGULAR_SIMPLIFIED		22
#define NS_CHINESE_LEGAL_TRADITIONAL			25
#define NS_CHINESE_MANDARIN_LEGAL_TRADITIONAL		26
#define NS_CHINESE_LEGAL_SIMPLIFIED			27
#define NS_CHINESE_MANDARIN_LEGAL_SIMPLIFIED		28
#define NS_CHINESE_JAPANESE_REGULAR_SIMPLIFIED		29
#define NS_CHINESE_JAPANESE_REGULAR_TRADITIONAL		30
#define NS_CHINESE_JAPANESE_REGULAR_PLACE		31
#define NS_CHINESE_JAPANESE_WESTERN_MIX			33
#define NS_CHINESE_JAPANESE_LEGAL_SIMPLIFIED		35
#define NS_CHINESE_JAPANESE_LEGAL_TRADITIONAL		36
#define NS_CYRILLIC_ALPHABETIC				39
#define NS_DEVANAGARI					41
#define NS_EGYPTIAN					43
#define NS_ETHIOPIC					45
#define NS_GLAGOLITIC_ALPHABETIC			47
#define NS_GREEK_ACROPHONIC				49
#define NS_GREEK_ALPHABETIC_UPPER			51
#define NS_GREEK_ALPHABETIC_LOWER			52
#define NS_GUJARATI					53
#define NS_GURMUKHI					55
#define NS_HEBREW_GENERIC				56
#define NS_HEBREW_EARLY					57
#define NS_HEBREW_LATE					59
#define NS_KANNADA					61
#define NS_KHAROSHTHI					63
#define NS_KHMER					65
#define NS_KLINGON					67
#define NS_LAO						69
#define NS_LIMBU					71
#define NS_MALAYALAM					73
#define NS_MAYAN					75
#define NS_MONGOLIAN					77
#define NS_MXEDRULI					78
#define NS_NEW_TAI_LUE					79
#define NS_NKO						81
#define NS_OLD_ITALIC					83
#define NS_OLD_PERSIAN					85
#define NS_ORIYA					87
#define NS_OSMANYA					89
#define NS_PERSO_ARABIC					91
#define NS_PHOENICIAN					93
#define NS_ROMAN_GENERIC				94
#define NS_ROMAN_UPPER					95
#define NS_ROMAN_LOWER					96
#define NS_SINHALA					97
#define NS_TAMIL_GENERIC				100
#define NS_TAMIL_PLACE					101
#define NS_TAMIL_TRADITIONAL				103
#define NS_TELUGU					105
#define NS_TENGWAR					107
#define NS_THAI						109
#define NS_TIBETAN					111
#define NS_XUCURI_LOWER					112
#define NS_XUCURI_UPPER					114
#define NS_ALL  					115
#define NS_ANY  					117
#define NS_HEX  					119
#define NS_WESTERN 					120
#define NS_WESTERN_LOWER				121
#define NS_WESTERN_UPPER				122
#define NS_CHINESE_COUNTING_ROD				123
#define NS_CHINESE_COUNTING_ROD_EARLY_WITH_ZERO		124
#define NS_CHINESE_COUNTING_ROD_LATE_WITH_ZERO		125
#define NS_CHINESE_COUNTING_ROD_EARLY_WITHOUT_ZERO	126
#define NS_CHINESE_COUNTING_ROD_LATE_WITHOUT_ZERO	127


/* Error codes */
#define NS_BADCHARACTER 128
#define NS_DOESNOTFIT 129
#define NS_UNKNOWN_ERR 130
#define NS_BADBASE 131
#define NS_NOTCONSISTENTWITHBASE 132
#define NS_OUTOFMEMORY 133
#define NS_RANGE_ERROR 134
#define NS_OUTSIDE_BMP_ERROR 135

/* Pass/return formats */
#define NS_TYPE_ULONG  0
#define NS_TYPE_STRING 1
#define NS_TYPE_MPZT 2

