/* Time-stamp: <2007-02-07 00:03:58 poser> */
/*
 * Copyright (C) 2006-2007 William J. Poser.
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General
 * Public License as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __GMP_H__
#include <gmp.h>
#endif
#ifndef __WCHAR_H__
#include <wchar.h>
#endif

#ifndef _UNICODE_POSER
#include "unicode.h"
#endif

union ns_rval {
  char *s;
  unsigned long u;
  mpz_t m;
};

struct vcpair {
  unsigned long v;
  wchar_t c;
};

#ifndef UNINUM
extern char *uninum_version(void);

extern char *UNStrToWNStr(wchar_t *s,char *sns); /* Tcl interface */
extern UTF16 *WNStrToUNStr(char *,char *); /* Tcl interface */
extern char *StrGuessNumberSystem(wchar_t *); /* Tcl interface */

extern void StringToInt(union ns_rval *, wchar_t *, short, int);
extern void ArabicToInt(union ns_rval *, wchar_t *, short);
extern void ArabicAlphabeticToInt(union ns_rval *, wchar_t *, short);
extern void ArabicExtendedToInt(union ns_rval *, wchar_t *, short);
extern void ArmenianAlphabeticToInt(union ns_rval *, wchar_t *, short);
extern void BalineseToInt(union ns_rval *, wchar_t *, short);
extern void BengaliToInt(union ns_rval *, wchar_t *, short);
extern void BurmeseToInt(union ns_rval *, wchar_t *, short);
extern void ChineseToInt(union ns_rval *, wchar_t *, short);
extern void CyrillicAlphabeticToInt(union ns_rval *, wchar_t *, short);
extern void DevanagariToInt(union ns_rval *, wchar_t *, short);
extern void EgyptianToInt(union ns_rval *, wchar_t *, short);
extern void EthiopicToInt(union ns_rval *, wchar_t *, short);
extern void GreekAlphabeticToInt(union ns_rval *, wchar_t *, short);
extern void GujaratiToInt(union ns_rval *, wchar_t *, short);
extern void GurmukhiToInt(union ns_rval *, wchar_t *, short);
extern void HebrewToInt(union ns_rval *, wchar_t *, short);
extern void KannadaToInt(union ns_rval *, wchar_t *, short);
extern void KharoshthiToInt(union ns_rval *, wchar_t *, short);
extern void KhmerToInt(union ns_rval *, wchar_t *, short);
extern void KlingonToInt(union ns_rval *, wchar_t *, short);
extern void LaoToInt(union ns_rval *, wchar_t *, short);
extern void LimbuToInt(union ns_rval *, wchar_t *, short);
extern void MalayalamToInt(union ns_rval *, wchar_t *, short);
extern void MongolianToInt(union ns_rval *, wchar_t *, short);
extern void NewTaiLueToInt(union ns_rval *, wchar_t *, short);
extern void NkoToInt(union ns_rval *, wchar_t *, short);
extern void OldItalicToInt(union ns_rval *, wchar_t *, short);
extern void OldPersianToInt(union ns_rval *, wchar_t *, short);
extern void OriyaToInt(union ns_rval *, wchar_t *, short);
extern void OsmanyaToInt(union ns_rval *, wchar_t *, short);
extern void PhoenicianToInt(union ns_rval *, wchar_t *, short);
extern void RomanToInt(union ns_rval *, wchar_t *, short);
extern void TamilToInt(union ns_rval *, wchar_t *, short);
extern void TeluguToInt(union ns_rval *, wchar_t *, short);
extern void TengwarToInt(union ns_rval *, wchar_t *, short);
extern void ThaiToInt(union ns_rval *, wchar_t *, short);
extern void TibetanToInt(union ns_rval *, wchar_t *, short);
extern void WesternToInt(union ns_rval *, wchar_t *, short);
extern void WesternGeneralToInt(union ns_rval *, wchar_t *, short, int);

extern int GuessNumberSystem(wchar_t *);
extern wchar_t wcStripSeparators (wchar_t *, wchar_t);
extern wchar_t *NormalizeChineseNumbers (wchar_t *);
extern int StringToNumberSystem (char *);
extern char *NumberSystemToString (int);
extern char *ListNumberSystems(int,int);
extern void GetLocaleGroupInfo(void);

extern wchar_t *IntToString(union ns_rval *, int, short);

extern int uninum_err;
extern wchar_t uninum_badchar;
extern UTF16 tcl_uninum_badchar;

/* Parameters governing string output */
extern int Uninum_Input_Base;
extern int Uninum_Output_Base;
extern int Uninum_Output_General_Group_Size;
extern int Uninum_Output_First_Group_Size;
extern UTF16 Uninum_Output_Group_Separator;
#endif

